From 839575f360b6c639560a264df9e56508ce253e64 Mon Sep 17 00:00:00 2001
From: Jack Magne <jmagne@dhcp-16-213.sjc.redhat.com>
Date: Tue, 3 Jun 2014 14:28:47 -0700
Subject: [PATCH] Initial enrollment progress.

1. Changed the names of some message classes.
2. Did some minor refactoring of methods needed by both the enroll and tps processor.
3. Created classes to handle the parsing and archival of PKCS#11 token data.
4. Created prep code for enrollment that reads in a bunch of config params and creates
convenience objects to carry the data instead of lengthy parameter lists we have had before.
5. Code to generate key on token, tested tpsclient so far.
6. Additional review changes, and merging.

Review changes.
---
 .../org/dogtagpki/tps/apdu/GenerateKeyAPDU.java    |  11 +-
 .../org/dogtagpki/tps/apdu/GenerateKeyECCAPDU.java |  11 +-
 .../src/org/dogtagpki/tps/main/TPSBuffer.java      |  61 ++
 .../src/org/dogtagpki/tps/main/TPSException.java   |   2 +-
 .../src/org/dogtagpki/tps/msg/ASQRequest.java      |  29 -
 .../src/org/dogtagpki/tps/msg/ASQRequestMsg.java   |  29 +
 .../src/org/dogtagpki/tps/msg/ASQResponse.java     |  29 -
 .../src/org/dogtagpki/tps/msg/ASQResponseMsg.java  |  29 +
 base/common/src/org/dogtagpki/tps/msg/BeginOp.java |  58 --
 .../src/org/dogtagpki/tps/msg/BeginOpMsg.java      |  58 ++
 base/common/src/org/dogtagpki/tps/msg/EndOp.java   | 244 --------
 .../common/src/org/dogtagpki/tps/msg/EndOpMsg.java | 244 ++++++++
 .../dogtagpki/tps/msg/ExtendedLoginRequest.java    |  91 ---
 .../dogtagpki/tps/msg/ExtendedLoginRequestMsg.java |  91 +++
 .../dogtagpki/tps/msg/ExtendedLoginResponse.java   |  53 --
 .../tps/msg/ExtendedLoginResponseMsg.java          |  53 ++
 .../src/org/dogtagpki/tps/msg/LoginRequest.java    |  32 -
 .../src/org/dogtagpki/tps/msg/LoginRequestMsg.java |  32 +
 .../src/org/dogtagpki/tps/msg/LoginResponse.java   |  29 -
 .../org/dogtagpki/tps/msg/LoginResponseMsg.java    |  29 +
 .../src/org/dogtagpki/tps/msg/NewPinRequest.java   |  30 -
 .../org/dogtagpki/tps/msg/NewPinRequestMsg.java    |  30 +
 .../src/org/dogtagpki/tps/msg/NewPinResponse.java  |  27 -
 .../org/dogtagpki/tps/msg/NewPinResponseMsg.java   |  27 +
 .../src/org/dogtagpki/tps/msg/SecureIdRequest.java |  30 -
 .../org/dogtagpki/tps/msg/SecureIdRequestMsg.java  |  30 +
 .../org/dogtagpki/tps/msg/SecureIdResponse.java    |  28 -
 .../org/dogtagpki/tps/msg/SecureIdResponseMsg.java |  28 +
 .../org/dogtagpki/tps/msg/StatusUpdateRequest.java |  36 --
 .../dogtagpki/tps/msg/StatusUpdateRequestMsg.java  |  36 ++
 .../dogtagpki/tps/msg/StatusUpdateResponse.java    |  29 -
 .../dogtagpki/tps/msg/StatusUpdateResponseMsg.java |  29 +
 .../src/org/dogtagpki/tps/msg/TPSMessage.java      |  12 +-
 .../src/org/dogtagpki/tps/msg/TokenPDURequest.java |  61 --
 .../org/dogtagpki/tps/msg/TokenPDURequestMsg.java  |  61 ++
 .../org/dogtagpki/tps/msg/TokenPDUResponse.java    |  68 ---
 .../org/dogtagpki/tps/msg/TokenPDUResponseMsg.java |  68 +++
 .../src/org/dogtagpki/server/tps/TPSSession.java   |  22 +-
 .../server/tps/channel/SecureChannel.java          | 130 ++++-
 .../org/dogtagpki/server/tps/engine/TPSEngine.java |  74 ++-
 .../dogtagpki/server/tps/main/AttributeSpec.java   |  71 +++
 .../org/dogtagpki/server/tps/main/ObjectSpec.java  | 456 +++++++++++++++
 .../org/dogtagpki/server/tps/main/PKCS11Obj.java   | 594 +++++++++++++++++++
 .../dogtagpki/server/tps/processor/AppletInfo.java |  77 +++
 .../server/tps/processor/CertEnrollInfo.java       | 162 ++++++
 .../server/tps/processor/EnrolledCertsInfo.java    | 113 ++++
 .../server/tps/processor/TPSEnrollProcessor.java   | 642 +++++++++++++++++++++
 .../server/tps/processor/TPSProcessor.java         | 546 ++++++++++++------
 .../tps/profile/MappingTokenProfileResolver.java   |   3 +-
 .../server/tps/profile/TokenProfileParams.java     |   5 +-
 50 files changed, 3673 insertions(+), 1067 deletions(-)
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/ASQRequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/ASQRequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/ASQResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/ASQResponseMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/BeginOp.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/BeginOpMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/EndOp.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/EndOpMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/ExtendedLoginRequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/ExtendedLoginRequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/ExtendedLoginResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/ExtendedLoginResponseMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/LoginRequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/LoginRequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/LoginResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/LoginResponseMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/NewPinRequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/NewPinRequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/NewPinResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/NewPinResponseMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/SecureIdRequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/SecureIdRequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/SecureIdResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/SecureIdResponseMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/StatusUpdateRequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/StatusUpdateRequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/StatusUpdateResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/StatusUpdateResponseMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/TokenPDURequest.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/TokenPDURequestMsg.java
 delete mode 100644 base/common/src/org/dogtagpki/tps/msg/TokenPDUResponse.java
 create mode 100644 base/common/src/org/dogtagpki/tps/msg/TokenPDUResponseMsg.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/main/AttributeSpec.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/main/ObjectSpec.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/main/PKCS11Obj.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/processor/AppletInfo.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/processor/CertEnrollInfo.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/processor/EnrolledCertsInfo.java
 create mode 100644 base/tps-tomcat/src/org/dogtagpki/server/tps/processor/TPSEnrollProcessor.java

diff --git a/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyAPDU.java b/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyAPDU.java
index f11f132..44b942f 100644
--- a/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyAPDU.java
+++ b/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyAPDU.java
@@ -46,10 +46,15 @@ public class GenerateKeyAPDU extends APDU {
         data.add((byte) wrapped_challenge.size());
         data.add(wrapped_challenge);
 
-        data.add((byte) key_check.size());
+        if (key_check != null) {
+            data.add((byte) key_check.size());
 
-        if (key_check.size() > 0) {
-            data.add(key_check);
+            if (key_check.size() > 0) {
+                data.add(key_check);
+            }
+
+        } else {
+            data.add((byte) 0);
         }
 
     }
diff --git a/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyECCAPDU.java b/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyECCAPDU.java
index 6743822..8d4a758 100644
--- a/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyECCAPDU.java
+++ b/base/common/src/org/dogtagpki/tps/apdu/GenerateKeyECCAPDU.java
@@ -49,10 +49,15 @@ public class GenerateKeyECCAPDU extends APDU {
 
         data1.add(wrapped_challenge);
 
-        data1.add((byte) key_check.size());
+        if (key_check != null) {
+            data1.add((byte) key_check.size());
 
-        if (key_check.size() > 0) {
-            data1.add(key_check);
+            if (key_check.size() > 0) {
+                data1.add(key_check);
+            }
+
+        } else {
+            data1.add((byte) 0);
         }
 
         setData(data1);
diff --git a/base/common/src/org/dogtagpki/tps/main/TPSBuffer.java b/base/common/src/org/dogtagpki/tps/main/TPSBuffer.java
index ef40a3a..d522c2a 100644
--- a/base/common/src/org/dogtagpki/tps/main/TPSBuffer.java
+++ b/base/common/src/org/dogtagpki/tps/main/TPSBuffer.java
@@ -220,6 +220,15 @@ public class TPSBuffer {
     }
 
     /**
+     * Get the SubString from start to the end
+     * @param start
+     * @return
+     */
+    public TPSBuffer substr(int start) {
+        return substr(start,buf.length -2);
+    }
+
+    /**
      * dump()s this Buffer to stdout.
      */
     public void dump() {
@@ -254,6 +263,58 @@ public class TPSBuffer {
         return result.toString();
     }
 
+    public int getIntFrom1Byte(int offset) {
+
+        if (offset < 0 || offset >= (this.size())) {
+            return 0;
+        }
+
+        int result = (this.at(offset) & 0xff);
+
+        return result;
+    }
+
+    public int getIntFrom2Bytes(int offset) {
+
+        if (offset < 0 || offset >= (this.size() - 1)) {
+            return 0;
+        }
+
+        int i1 = (this.at(offset) & 0xff) << 8;
+        int i2 = this.at(offset + 1) & 0xff;
+
+        return i1 + i2;
+    }
+
+    public void addLong4Bytes(long value) {
+
+        this.add((byte) ((value >> 24) & 0xff));
+
+        this.add((byte) ((value >> 16) & 0xff));
+        this.add((byte) ((value >> 8) & 0xff));
+        this.add((byte) (value & 0xff));
+    }
+
+    public void addInt2Bytes(int value) {
+        this.add((byte) ((value >> 8) & 0xff));
+        this.add((byte) (value & 0xff));
+    }
+
+    public long getLongFrom4Bytes(int offset) {
+
+        if (offset < 0 || offset >= (this.size() - 3)) {
+            return 0;
+        }
+
+        long l1 = (long) (this.at(offset + 0) & 0xff) << 24;
+
+        long l2 = (long) (this.at(offset + 1) & 0xff) << 16;
+        long l3 = (long) (this.at(offset + 2) & 0xff) << 8;
+        long l4 = this.at(offset + 3) & 0xff;
+
+        return l1 + l2 + l3 + l4;
+    }
+
     public static void main(String[] args) {
 
         byte[] first = { 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a };
diff --git a/base/common/src/org/dogtagpki/tps/main/TPSException.java b/base/common/src/org/dogtagpki/tps/main/TPSException.java
index ee3ef57..0d89aae 100644
--- a/base/common/src/org/dogtagpki/tps/main/TPSException.java
+++ b/base/common/src/org/dogtagpki/tps/main/TPSException.java
@@ -17,7 +17,7 @@
 // --- END COPYRIGHT BLOCK ---
 package org.dogtagpki.tps.main;
 
-import org.dogtagpki.tps.msg.EndOp.TPSStatus;
+import org.dogtagpki.tps.msg.EndOpMsg.TPSStatus;
 
 import com.netscape.certsrv.base.EBaseException;
 
diff --git a/base/common/src/org/dogtagpki/tps/msg/ASQRequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/ASQRequestMsg.java
new file mode 100644
index 0000000..f6d3aed
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/ASQRequestMsg.java
@@ -0,0 +1,29 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class ASQRequestMsg extends TPSMessage {
+    public ASQRequestMsg(String question) {
+
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_ASQ_REQUEST));
+        put(QUESTION_NAME,question);
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/ASQResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/ASQResponseMsg.java
new file mode 100644
index 0000000..1f093ab
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/ASQResponseMsg.java
@@ -0,0 +1,29 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class ASQResponseMsg extends TPSMessage {
+
+    public ASQResponseMsg(String answer) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_ASQ_RESPONSE));
+        put(QUESTION_NAME,answer);
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/BeginOpMsg.java b/base/common/src/org/dogtagpki/tps/msg/BeginOpMsg.java
new file mode 100644
index 0000000..250e5c0
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/BeginOpMsg.java
@@ -0,0 +1,58 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+import java.util.Map;
+
+import com.netscape.certsrv.apps.CMS;
+
+public class BeginOpMsg extends TPSMessage {
+
+    private Map<String, String> extensions;
+
+    public BeginOpMsg(OpType theOp, Map<String, String> theExtensions) {
+
+        CMS.debug("BeingOp op: " + theOp + " extensions: " + theExtensions);
+        put(OPERATION_TYPE_NAME, opTypeToInt(theOp));
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_BEGIN_OP));
+        extensions = theExtensions;
+
+    }
+
+    public OpType getOpType() {
+
+        int opTypeInt = getInt(OPERATION_TYPE_NAME);
+        return intToOpType(opTypeInt);
+    }
+
+    public Map<String, String> getExtensions() {
+        return extensions;
+    }
+
+    public String getExtension(String extName) {
+
+        String result = null;
+
+        if (extName == null)
+            return result;
+
+        return extensions.get(extName);
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/EndOpMsg.java b/base/common/src/org/dogtagpki/tps/msg/EndOpMsg.java
new file mode 100644
index 0000000..2518985
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/EndOpMsg.java
@@ -0,0 +1,244 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+
+public class EndOpMsg extends TPSMessage {
+
+    public enum TPSStatus {
+        STATUS_NO_ERROR,
+        STATUS_ERROR_SNAC,
+        STATUS_ERROR_SEC_INIT_UPDATE,
+        STATUS_ERROR_CREATE_CARDMGR,
+        STATUS_ERROR_MAC_RESET_PIN_PDU,
+        STATUS_ERROR_MAC_CERT_PDU,
+        STATUS_ERROR_MAC_LIFESTYLE_PDU,
+        STATUS_ERROR_MAC_ENROLL_PDU,
+        STATUS_ERROR_READ_OBJECT_PDU,
+        STATUS_ERROR_BAD_STATUS,
+        STATUS_ERROR_CA_RESPONSE,
+        STATUS_ERROR_READ_BUFFER_OVERFLOW,
+        STATUS_ERROR_TOKEN_RESET_PIN_FAILED,
+        STATUS_ERROR_CONNECTION,
+        STATUS_ERROR_LOGIN,
+        STATUS_ERROR_DB,
+        STATUS_ERROR_TOKEN_DISABLED,
+        STATUS_ERROR_SECURE_CHANNEL,
+        STATUS_ERROR_MISCONFIGURATION,
+        STATUS_ERROR_UPGRADE_APPLET,
+        STATUS_ERROR_KEY_CHANGE_OVER,
+        STATUS_ERROR_EXTERNAL_AUTH,
+        STATUS_ERROR_DEFAULT_TOKENTYPE_NOT_FOUND,
+        STATUS_ERROR_DEFAULT_TOKENTYPE_PARAMS_NOT_FOUND,
+        STATUS_ERROR_PUBLISH,
+        STATUS_ERROR_LDAP_CONN,
+        STATUS_ERROR_DISABLED_TOKEN,
+        STATUS_ERROR_NOT_PIN_RESETABLE,
+        STATUS_ERROR_CONN_LOST,
+        STATUS_ERROR_CREATE_TUS_TOKEN_ENTRY,
+        STATUS_ERROR_NO_SUCH_TOKEN_STATE,
+        STATUS_ERROR_NO_SUCH_LOST_REASON,
+        STATUS_ERROR_UNUSABLE_TOKEN_KEYCOMPROMISE,
+        STATUS_ERROR_INACTIVE_TOKEN_NOT_FOUND,
+        STATUS_ERROR_HAS_AT_LEAST_ONE_ACTIVE_TOKEN,
+        STATUS_ERROR_CONTACT_ADMIN,
+        STATUS_ERROR_RECOVERY_IS_PROCESSED,
+        STATUS_ERROR_RECOVERY_FAILED,
+        STATUS_ERROR_NO_OPERATION_ON_LOST_TOKEN,
+        STATUS_ERROR_KEY_ARCHIVE_OFF,
+        STATUS_ERROR_NO_TKS_CONNID,
+        STATUS_ERROR_UPDATE_TOKENDB_FAILED,
+        STATUS_ERROR_REVOKE_CERTIFICATES_FAILED,
+        STATUS_ERROR_NOT_TOKEN_OWNER,
+        STATUS_ERROR_RENEWAL_IS_PROCESSED,
+        STATUS_ERROR_RENEWAL_FAILED
+    };
+
+
+    public static final int  RESULT_GOOD = 0;
+    public static final int  RESULT_ERROR = 1;
+
+
+    public EndOpMsg(OpType theOp, int result, TPSStatus message) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_END_OP));
+        put(OPERATION_TYPE_NAME, opTypeToInt(theOp));
+        put(RESULT_NAME, result);
+        put(MESSAGE_NAME, statusToInt(message));
+    }
+
+    public static int statusToInt(TPSStatus status) {
+
+        int result = 0;
+
+        switch (status) {
+        case STATUS_NO_ERROR:
+            result = 0;
+            break;
+        case STATUS_ERROR_SNAC:
+            result = 1;
+            break;
+        case STATUS_ERROR_SEC_INIT_UPDATE:
+            result = 2;
+            break;
+        case STATUS_ERROR_CREATE_CARDMGR:
+            result = 3;
+            break;
+        case STATUS_ERROR_MAC_RESET_PIN_PDU:
+            result = 4;
+            break;
+        case STATUS_ERROR_MAC_CERT_PDU:
+            result = 5;
+            break;
+        case STATUS_ERROR_MAC_LIFESTYLE_PDU:
+            result = 6;
+            break;
+        case STATUS_ERROR_MAC_ENROLL_PDU:
+            result = 7;
+            break;
+        case STATUS_ERROR_READ_OBJECT_PDU:
+            result = 8;
+            break;
+        case STATUS_ERROR_BAD_STATUS:
+            result = 9;
+            break;
+        case STATUS_ERROR_CA_RESPONSE:
+            result = 10;
+            break;
+        case STATUS_ERROR_READ_BUFFER_OVERFLOW:
+            result = 11;
+            break;
+        case STATUS_ERROR_TOKEN_RESET_PIN_FAILED:
+            result = 12;
+            break;
+        case STATUS_ERROR_CONNECTION:
+            result = 13;
+            break;
+        case STATUS_ERROR_LOGIN:
+            result = 14;
+            break;
+        case STATUS_ERROR_DB:
+            result = 15;
+            break;
+        case STATUS_ERROR_TOKEN_DISABLED:
+            result = 16;
+            break;
+        case STATUS_ERROR_SECURE_CHANNEL:
+            result = 17;
+            break;
+        case STATUS_ERROR_MISCONFIGURATION:
+            result = 18;
+            break;
+        case STATUS_ERROR_UPGRADE_APPLET:
+            result = 19;
+            break;
+        case STATUS_ERROR_KEY_CHANGE_OVER:
+            result = 20;
+            break;
+        case STATUS_ERROR_EXTERNAL_AUTH:
+            result = 21;
+            break;
+        case STATUS_ERROR_DEFAULT_TOKENTYPE_NOT_FOUND:
+            result = 22;
+            break;
+        case STATUS_ERROR_DEFAULT_TOKENTYPE_PARAMS_NOT_FOUND:
+            result = 23;
+            break;
+        case STATUS_ERROR_PUBLISH:
+            result = 24;
+            break;
+        case STATUS_ERROR_LDAP_CONN:
+            result = 25;
+            break;
+        case STATUS_ERROR_DISABLED_TOKEN:
+            result = 26;
+            break;
+        case STATUS_ERROR_NOT_PIN_RESETABLE:
+            result = 27;
+            break;
+        case STATUS_ERROR_CONN_LOST:
+            result = 28;
+            break;
+        case STATUS_ERROR_CREATE_TUS_TOKEN_ENTRY:
+            result = 29;
+            break;
+        case STATUS_ERROR_NO_SUCH_TOKEN_STATE:
+            result = 30;
+            break;
+        case STATUS_ERROR_NO_SUCH_LOST_REASON:
+            result = 31;
+            break;
+        case STATUS_ERROR_UNUSABLE_TOKEN_KEYCOMPROMISE:
+            result = 32;
+            break;
+        case STATUS_ERROR_INACTIVE_TOKEN_NOT_FOUND:
+            result = 33;
+            break;
+        case STATUS_ERROR_HAS_AT_LEAST_ONE_ACTIVE_TOKEN:
+            result = 34;
+            break;
+        case STATUS_ERROR_CONTACT_ADMIN:
+            result = 35;
+            break;
+        case STATUS_ERROR_RECOVERY_IS_PROCESSED:
+            result = 36;
+            break;
+        case STATUS_ERROR_RECOVERY_FAILED:
+            result = 37;
+            break;
+        case STATUS_ERROR_NO_OPERATION_ON_LOST_TOKEN:
+            result = 38;
+            break;
+        case STATUS_ERROR_KEY_ARCHIVE_OFF:
+            result = 39;
+            break;
+        case STATUS_ERROR_NO_TKS_CONNID:
+            result = 40;
+            break;
+        case STATUS_ERROR_UPDATE_TOKENDB_FAILED:
+            result = 41;
+            break;
+        case STATUS_ERROR_REVOKE_CERTIFICATES_FAILED:
+            result = 42;
+            break;
+        case STATUS_ERROR_NOT_TOKEN_OWNER:
+            result = 43;
+            break;
+        case STATUS_ERROR_RENEWAL_IS_PROCESSED:
+            result = 44;
+            break;
+        case STATUS_ERROR_RENEWAL_FAILED:
+            result = 45;
+            break;
+        default:
+            break;
+        }
+
+        return result;
+
+    }
+
+    public static void main(String[] args) {
+
+        EndOpMsg end_msg = new EndOpMsg(OpType.OP_FORMAT,0,TPSStatus.STATUS_NO_ERROR);
+        System.out.println(end_msg.encode());
+
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/ExtendedLoginRequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/ExtendedLoginRequestMsg.java
new file mode 100644
index 0000000..e59f80f
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/ExtendedLoginRequestMsg.java
@@ -0,0 +1,91 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+import java.io.UnsupportedEncodingException;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Set;
+
+import org.dogtagpki.tps.main.Util;
+
+public class ExtendedLoginRequestMsg extends TPSMessage {
+
+    private Set<String> params;
+
+    public ExtendedLoginRequestMsg(int invalid_pw, int blocked, Set<String> params, String title, String description) {
+
+        put(INVALID_PWD_NAME, invalid_pw);
+        put(BLOCKED_NAME, blocked);
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_EXTENDED_LOGIN_REQUEST));
+        put(TITLE_NAME, title);
+        put (DESCRIPTION_NAME, description);
+        this.params = params;
+
+    }
+
+    @Override
+    public String encode() {
+
+        if (!params.isEmpty()) {
+
+            int i = 0;
+            for (Iterator<String> iter = params.iterator(); iter.hasNext();) {
+
+                String curParam = null;
+
+                try {
+                    curParam = Util.uriEncode(iter.next());
+                } catch (UnsupportedEncodingException e) {
+                    curParam = null;
+                }
+
+                if (curParam != null && curParam.length() > 0) {
+
+                    String name = "&" + PARAMETER_NAME + Integer.toString(i++);
+                    String value = curParam;
+
+                    put(name, value);
+
+                }
+
+            }
+
+        }
+
+        return super.encode();
+
+    }
+
+    public static void main(String[] args) {
+
+        final String title = "LDAP Authentication";
+        final String description = "This authenticates user against the LDAP directory.";
+
+        Set<String> params = new HashSet<String>();
+
+        params.add("id=UID&name=LDAP User ID&desc=LDAP User ID&type=string&option=");
+        params.add("id=PASSWORD&name=LDAP Password&desc=LDAP Password&type=password&option=");
+
+        ExtendedLoginRequestMsg ext_login_req = new ExtendedLoginRequestMsg(0, 0, params, title, description);
+
+        System.out.println(ext_login_req.encode());
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/ExtendedLoginResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/ExtendedLoginResponseMsg.java
new file mode 100644
index 0000000..173a775
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/ExtendedLoginResponseMsg.java
@@ -0,0 +1,53 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class ExtendedLoginResponseMsg extends TPSMessage {
+
+    private Map<String, String> authParams;
+
+    public ExtendedLoginResponseMsg(String msg) {
+
+        super(msg);
+
+        authParams = new HashMap<String, String>();
+        //ToDo process the actual params
+    }
+
+    public ExtendedLoginResponseMsg(OpType theOp, String uid, String password, Map<String, String> theExtensions) {
+
+        put(OPERATION_TYPE_NAME, opTypeToInt(theOp));
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_EXTENDED_LOGIN_RESPONSE));
+        authParams = theExtensions;
+        put(SCREEN_NAME_NAME, uid);
+        put(PASSWORD_NAME, password);
+
+    }
+
+    public static void main(String[] args) {
+
+    }
+
+    public Map<String, String> getAuthParams() {
+        return authParams;
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/LoginRequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/LoginRequestMsg.java
new file mode 100644
index 0000000..922927f
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/LoginRequestMsg.java
@@ -0,0 +1,32 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class LoginRequestMsg extends TPSMessage {
+
+    public LoginRequestMsg(int invalid_pwd, int blocked) {
+
+        put(INVALID_PWD_NAME, invalid_pwd);
+        put(BLOCKED_NAME,blocked);
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_LOGIN_REQUEST));
+
+    }
+
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/LoginResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/LoginResponseMsg.java
new file mode 100644
index 0000000..71096d2
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/LoginResponseMsg.java
@@ -0,0 +1,29 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class LoginResponseMsg  extends TPSMessage {
+
+    public LoginResponseMsg(String uid, String password ) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_LOGIN_RESPONSE));
+        put(SCREEN_NAME_NAME,uid);
+        put(PASSWORD_NAME, password);
+
+    }
+}
